package net.nevet5.buzzbot.database;

import net.nevet5.buzzbot.Config;
import net.nevet5.buzzbot.objects.BanData;

import java.sql.*;

public class SqlDB {
    //TODO Make this a two way class for reading and writing from db

    private Connection connect;
    private Statement statement;
    private ResultSet resultSet;

    public SqlDB() {
        try {
            Class.forName("com.mysql.jdbc.Driver");
            connect = DriverManager.getConnection("jdbc:mysql://" + Config.getConfig().getString("database.url") + "/" + Config.getConfig().getString("database.database"), Config.getConfig().getString("database.user"), Config.getConfig().getString("database.password"));
            statement = connect.createStatement();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void insertBan(BanData ban, String table) {
        try {
            System.out.println("Created Statement");
            statement.executeUpdate("INSERT INTO " + table + " VALUES (default, " + ban.getUserId() + ", '" + ban.getUserName() + "', '" + ban.getUserDiscriminator() + "', '" + ban.getDate() + "', '" + ban.getTime() + "', " + ban.getBanType() + ", " + ban.getBanLength() + ", '" + ban.getBanReason() + "', '" + ban.getModName() + "', " + ban.getModId() + ", '" + ban.getServerName() + "', " + ban.getServerId() + ")");
            System.out.println("Executed Statement");
            close();
            System.out.println("Closed");
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }

    private BanData query(long userId) throws SQLException {
        BanData ban = new BanData();

        String group = "masterbanlist"; //TODO Make this use GuildUtils in order to get the proper group for the server

        resultSet = statement.executeQuery("SELECT * IN " + group + " WHERE userId='" + userId + "'");

        while (resultSet.next()) {
            ban.setUserId(resultSet.getLong("userid"));
            ban.setUserName(resultSet.getString("username"));
            ban.setUserDiscriminator(resultSet.getInt("userdiscriminator"));
            ban.setDate(resultSet.getDate("bandate"));
            ban.setTime(resultSet.getTime("bantime"));
            ban.setBanType(resultSet.getBoolean("bantype"));
            ban.setBanLength(resultSet.getInt(""));
            ban.setBanReason(resultSet.getString("banreason"));
            ban.setModName(resultSet.getString("modname"));
            ban.setModId(resultSet.getLong("modid"));
            ban.setServerName(resultSet.getString("servername"));
            ban.setServerId(resultSet.getLong("serverid"));
        }

        return ban;
    }

    private void close() {
        try {
            //if (resultSet != null) {
            //    resultSet.close();
            //}

            if (statement != null) {
                statement.close();
            }

            if (connect != null) {
                connect.close();
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }

}
