package net.nevet5.buzzbot.util;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import net.nevet5.buzzbot.objects.UserData;

import java.io.*;
import java.lang.reflect.Type;

public class JsonUtils <T extends UserData> {
    T object;

    public void createJson(T object) throws IOException {
        Writer writer = new FileWriter("./" + object.getName() + ".json");

        GsonBuilder builder = new GsonBuilder();
        builder.setPrettyPrinting();
        Gson gson = builder.create();
        String jsonString = gson.toJson(object);
        writer.write(jsonString);
        writer.close();
    }

    public T loadJson(String jsonFileName) throws FileNotFoundException {
        BufferedReader reader = new BufferedReader(new FileReader("./" + jsonFileName + ".json"));

        return new Gson().fromJson(reader, (Type) object);
    }
}